
var toolbar_plot = new function() {
	
	this.init = function() {
		this.icon = $("<img src='images/plotting.png' class='toolbar_icon'>");
		this.print_icon = $("<img src='images/print.png' class='toolbar_icon inline_icon'>").css("padding", "3px");
	}
	
	// whether icon should be shown on main toolbar
	this.ready = function() {
        if (toolbar_military.is_mil()) return false;
		return cur_user() != null || !g_config.use_role_shooter;
	}
	
	// try to open this panel (return false to cancel)
	this.show = function() {
		plotting.enable_view = true;
		plotting.enable_controls = true;
		return true;
	}
	
	// try to close this panel (return false to cancel)
	this.hide = function() {
		plotting.enable_view = false;
		plotting.enable_controls = false;
		return true;
	}
	
	// display the panel in the supplied div
	this.draw = function(div) {

		// enable/disable plot view
		toolbar.new_button(div, S("PLOT_MODE"), function() {
			var setting = !plotting.enable_view;
			plotting.enable_view = setting;
			plotting.enable_controls = setting;
			update();
		}, plotting.enable_view);

		if (window.print) {
			this.print_icon.mousedown(function() {
				print_screen();
			});
			div.append(this.print_icon);
		}
		
	}
	
	
}

