/*******************************************************************************
 $Author: dmc $
 $Revision: 2725 $
 $Date: 2020-04-08 14:44:28 -0300 (Wed, 08 Apr 2020) $
 $HeadURL: http://support2.silvermountaintargets.com/svn/smt/smtv2-lodi/public/javascripts/viewer_toolbar_string.js $
*******************************************************************************/

var toolbar_string = new function() {

	this.init = function() {
		this.icon = $("<img src='images/admin_face.png' class='toolbar_icon'>");
		this.admin_icon = $("<img src='images/admin.png' class='toolbar_icon inline_icon'>").css("padding", "3px");
	}
	
	// whether icon should be shown on main toolbar
	this.ready = function() {
        if (toolbar_military.is_mil()) return false;
		var is_scorer = cur_user() && g_config.use_role_scorer && cur_string().data.role_scorer == cur_user().id();
		return admin_check() || ro_check() || is_scorer;
	}
	
	// try to open this panel (return false to cancel)
	this.show = function() {
		return true;
	}
	
	// try to close this panel (return false to cancel)
	this.hide = function() {
		return true;
	}
	
	// display the panel in the supplied div
	this.draw = function(div) {
		// var string = cur_string();
		var ready = get_target_ready_status(cur_string().id());
		var text = cur_string().frame().data.name + " status: " + ready.text;
		var item = toolbar.new_text(div, text);
		item.addClass(ready.css);

		div.append("<hr>");

		toolbar_string.draw_chooseTargetFaces(div);
		
		toolbar_string.draw_chooseGrid(div);

		div.append("<br>");

		toolbar_string.draw_chooseNumShooters(div);
		
		toolbar_string.draw_chooseShooterScorer(div);
		
	}
	
}

toolbar_string.draw_chooseTargetFaces = function (div) {
	// var string = cur_string();

	var face_list = [];
	for (var i in g_faces) {
		var face = g_faces[i];
		if (face.data.enabled) // only active faces show in list
			face_list.push(i);
	}

	// sort by distance
	face_list.sort(function (a, b) {
		if (g_faces[a].data.distance < g_faces[b].data.distance) return -1;
		if (g_faces[a].data.distance > g_faces[b].data.distance) return 1;
		return 0;
	});

	if (face_list.length == 0) {
		toolbar.new_text(div, S("FACE_NONEACTIVE"));

		this.admin_icon.mousedown(function () {
			if (toolbar.back() && toolbar.set_panel(toolbar_system)) {
				toolbar_system.set_tab("faces");
			}
			update();
		});
		div.append(this.admin_icon);

		div.append("<br>");

	} else {
		// new method: select target face as buttons
		toolbar.new_text(div, S("FACE_SELECT", cur_string().frame().data.name));
		div.append("<br>");

		var inner = $("<div>");
		div.append(inner);
		inner.css("overflow-x", "scroll");

		var selected_td = null; // for scrolling

		var table = $("<table>");
		table.css("background-color", "transparent");
		table.css("margin-left", "30px");
		inner.append(table);

		var tr = $("<tr>");
		table.append(tr);

		for (var i in face_list) {
			var face = g_faces[face_list[i]];

			var td = $("<td>");
			td.css("background-color", "transparent");
			tr.append(td);
			var is_fclass = face.data.scoringzones_f;
			var item = toolbar.new_button(td, face.data.name, function () {

				if (cur_string().face().id() != this.arg) {

					//if (cur_string().data.shots.length > 0
					// && !confirm(S("FACE_SELECT_CONFIRM", cur_string().data.shots.length)))
					// return;

					cur_string().crud({ face_id: this.arg });
					g_socket.emit("recalc_shot_scores", cur_string().id());
					g_socket.emit("update_string_stats", cur_string().id());

				} else {

					if (confirm(S("FACE_SELECT_ALL_CONFIRM"))) {
						for (var i in g_strings) {
							var str = g_strings[i];
							if (str.frame().data.enabled && str.frame().string().id() == str.id()) {
								str.crud({ face_id: this.arg });
								g_socket.emit("recalc_shot_scores", str.id());
								g_socket.emit("update_string_stats", str.id());
							}
						}
					}
				}

			}, cur_string().face() == face);
			if (is_fclass) item.css("text-decoration", "underline");
			item[0].arg = face_list[i];

			// buttons are fixed size and compact
			item.css("font-size", "16px");
			item.css("line-height", "14px");
			item.css("width", "80px");
			item.css("height", "60px");
			item.css("padding", "4px");
			item.css("margin", "0px");
			item.css("vertical-align", "middle");
			item.css("word-wrap", "break-word");

			if (cur_string().face() == face) selected_td = td;

		}

		// limit width of div to maintarget
		var width = inner.width();
		var width_parent = maintarget.div[0].clientWidth;
		if (width > width_parent - 50) width = width_parent - 50;
		inner.css("width", width + "px");

		// scroll to center selected face
		if (selected_td != null) {
			var center_div = inner[0].clientWidth / 2;
			var center_face = selected_td[0].offsetLeft + selected_td[0].clientWidth / 2;
			inner.scrollLeft(center_face - center_div);
		}

	}
}

toolbar_string.draw_chooseGrid = function (div) {
	toolbar.new_text(div, "Grid:"); // rework: S("ADMIN_OPTIONS_GRID")

	toolbar.new_button(div, S("ADMIN_OPTIONS_GRID_MOA"), function () {
		config_crud({ option_grid_unit: "moa" });
	}, g_config.option_grid_unit == "moa").addClass("button_small");

	toolbar.new_button(div, "0.1 mil", function () { // S("ADMIN_OPTIONS_GRID_MIL")
		config_crud({ option_grid_unit: "mil" });
	}, g_config.option_grid_unit == "mil").addClass("button_small");

	if (toolbar_military.is_mil()) {
		toolbar.new_button(div, "RMR", function () { // S("ADMIN_OPTIONS_GRID_MIL")
			config_crud({ option_grid_unit: "RMR" });
		}, g_config.option_grid_unit == "RMR").addClass("button_small");
	}

	// toolbar.new_button(div, "mil-20", function () {
	// 	config_crud({ option_grid_unit: "mil20" });
	// }, g_config.option_grid_unit == "mil20").addClass("button_small");

	toolbar.new_button(div, S('ADMIN_OPTIONS_GRID_NONE'), function () {
		config_crud({ option_grid_unit: 'none' });
	}, g_config.option_grid_unit == 'none').addClass("button_small");
}

toolbar_string.draw_chooseNumShooters = function (div) {
	var string = cur_string();
	// select number of shooters on the target
	toolbar.new_text(div, S("FACE_SHOOTERCOUNT"));

	for (var i = 1; i <= 3; i++) {
		var item = toolbar.new_button(div, i, function () {
			var count = this.arg;
			var frame = cur_string().frame();

			// apply to current string
			if (string.data.shooter_count != count) {
				string.frame().crud({ string_params: { shooter_count: count } });
				string.crud({ shooter_count: count });
				g_socket.emit("update_string_stats", string.id());

				// pressed again, apply to all strings
			} else {
				if (confirm(S("FACE_SHOOTERCOUNT_ALL_CONFIRM"))) {
					for (var i in g_strings) {
						var str = g_strings[i];
						if (str.frame().data.enabled && str.frame().string().id() == str.id()) {
							str.frame().crud({ string_params: { shooter_count: count } });
							str.crud({ shooter_count: count });
							g_socket.emit("update_string_stats", i);
						}
					}
				}
			}

		}, string.data.shooter_count == i);
		item[0].arg = i;
		item.css("font-size", "30px");
		item.css("width", "50px");
		item.css("margin", "5px");
	}
}

toolbar_string.draw_chooseShooterScorer = function (div) {
	var string = cur_string();

	if (!g_config.use_role_shooter && !g_config.use_role_scorer) {
		return;
	}

	var use_registered_only = cur_event() && numberof(cur_event().shooters) > 0;

	var user_list = null;
	var shooter_list = null;

	function get_user_list() {
		if (!user_list) {
			user_list = {};
			user_list[0] = { value: 0, text: "None" };
			for (var i in g_users) {
				var user = g_users[i];
				if (user.data.name == "admin") continue;
				user_list[i] = { value: i, text: user_display_name(i) };
			}
		}
		return user_list;
	}

	function get_shooter_list() {
		if (!shooter_list) {
			if (!use_registered_only) return get_user_list();
			shooter_list = {};
			shooter_list[0] = { value: 0, text: "None" };
			var event = cur_event();
			for (var i in event.shooters) {
				var user = g_users[i];
				shooter_list[i] = { value: i, text: user_display_name(i) };
			}
		}
		return shooter_list;
	}

	if (g_config.use_role_scorer) {

		div.append("<br>");
		toolbar.new_text(div, toolbar_military.stringname_Scorer()+":"/*"Scorekeeper:"*/); // todo

		var item = toolbar.new_button(div, "Set", function () {
			var name = prompt("Enter username / competitor number");
			if (name == null) return;
			if (!name || name == "0") {
				user_assign_scorer(string.id(), 0);
				return;
			}

			var list = get_user_list();
			for (var i in list) {
				var user_id = list[i].value;
				if (g_users[user_id] && name == g_users[user_id].data.name) {
					user_assign_scorer(string.id(), user_id);
					return;
				}
			}

			alert("username not recognized!");

		});

		// select user
		var item = toolbar.new_dropdown(div, get_user_list(), function (item) {
			var id = item.val(); // val() always returns a string
			if (!id || id == "0") id = 0; // select 'none'

			user_assign_scorer(string.id(), id);

		}, string.data.role_scorer || 0);

	}

	if (g_config.use_role_shooter) {

		var shooter_count = string.data.shooter_count || 1;

		for (var i = 0; i < shooter_count; i++) {

			div.append("<br>");

			var str = toolbar_military.stringname_Shooter(i,shooter_count); // "Firer", "Shooter", "Left Shooter", etc
			toolbar.new_text(div, str + ":"); // todo

			// id of user currently in this shooter slot
			var cur = 0;
			if (string.data.role_shooter && string.data.role_shooter[i]) {
				cur = string.data.role_shooter[i];
			}

			var item = toolbar.new_button(div, "Set", function () {
				var name = prompt("Enter username / competitor number");
				if (name == null) return;
				if (!name || name == "0") {
					user_assign_shooter(string.id(), 0, this.arg);
					return;
				}

				var list = get_shooter_list();
				for (var i in list) {
					var user_id = list[i].value;
					if (g_users[user_id] && name == g_users[user_id].data.name) {
						user_assign_shooter(string.id(), user_id, this.arg);
						return;
					}
				}

				alert("username not recognized!");

			});
			item[0].arg = i;

			// select new user
			var item = toolbar.new_dropdown(div, get_shooter_list(), function (item, index) {
				var id = item.val(); // val() always returns a string
				if (!id || id == "0") id = 0; // select 'none'

				user_assign_shooter(string.id(), id, index);

			}, cur, i);
		}
	}
}
