#!/bin/sh

# 
# $Author: dmc $
# $Revision: 2753 $
# $Date: 2020-05-28 13:40:38 -0300 (Thu, 28 May 2020) $
# $HeadURL: http://support2.silvermountaintargets.com/svn/smt/smtv2-lodi/set_altnetwork.sh $
#
prefix1=SilverMountain
suffix1=Targets

prefix2=SMTserver
suffix2=Uplink

prm=${1:-0}

change_ssid() {
	prefix=$1; suffix=$2
	list=`uci show wireless | grep ssid | grep $prefix | cut -d= -f1`
	for i in $list; do
		echo uci set $i=${prefix}${suffix}
		uci set $i=${prefix}${suffix}
	done
}

if [ "$prm" -ge 1 -a $prm -le 4 ]; then
	suffix1=$prm
	suffix2=$prm
fi

echo set_altnetwork.sh $prm "===>" using SSIDs ${prefix1}${suffix1} and ${prefix2}${suffix2}
change_ssid $prefix1 $suffix1
change_ssid $prefix2 $suffix2
uci commit

S7_FSOLO_ip=192.168.0.7
echo
echo checking server type, looking for S7 FSOLO at $S7_FSOLO_ip

if wget -O - http://${S7_FSOLO_ip}/set_altnetwork/${prm} > /dev/null
then
	echo
	echo we are an S7; S7 FSOLO found!
	wget -O - http://${S7_FSOLO_ip}/serialno_password
else
	echo
	echo 'we are NOT an S7; FSOLO not found *** or not updated with latest firmware ***'
fi

exit 0
