/*******************************************************************************
 client_device.js: client class for connected devices

 $Author: dmc $
 $Revision: 2592 $
 $Date: 2019-06-02 14:43:10 -0300 (Sun, 02 Jun 2019) $
 $HeadURL: http://support2.silvermountaintargets.com/svn/smt/smt.common.lib/public/javascripts/client_device.js $
*******************************************************************************/

// Device: a target, repeater, or separate server

// everything in 'data' is synced with the server
// everything else is client-side only

function ClientDevice( data ) {
	this.data = data;

	//log("creating device: " + data.ip);

	this.crud = function(delta) {
		var msg = new_crud();
		msg.devices[this.id()] = delta;
		log("device.crud()", msg);
		g_socket.emit("crud", msg);
	};

	this.id = function() {
		if ( this.data.type === "SOLO" ) {
			return this.data.serialno;
		}
		return this.data.ip;
	};

	// currently associated frame
	this.frame = function() {
		if ( !this.data.assoc_frame_id ) {
			return null;
		}
		return g_frames[ this.data.assoc_frame_id ];
	};

	this.end_of_ip = function() { // should be renamed to something like "device_short_name"
		if ( data.type === "SOLO" ) {
//			return data.deviceIP;
			return data.serialno;
		}
		if ('string' != typeof data.ip) {
			return 'nil';
		}
		var parts = data.ip.split( "." );
		return parts[ parts.length - 1 ];
	};

}

